extends ../_docs-template

block vars
  - var title = 'Messages | Framework7 Documentation';

block docs-index

block content


  .docs-nav
    include ../_docs-menu
  .docs-content

    .motion-docs-page-title
      h1 Messages
      script(src="/js/motion/messages.js")
      f7-motion-messages(motion)

    p Messages component will help you with visualisation of comments and messaging system in your app.
    h2 Messages Layout
    :code(lang="html")
      <div class="page">
        <div class="page-content messages-content">
          <div class="messages">
            <!-- Date stamp -->
            <div class="messages-title"><b>Sunday, Feb 9</b> 12:58</div>

            <!-- Sent message (by default - green and on right side) -->
            <div class="message message-sent">
              <div class="message-content">
                <!-- Bubble with text -->
                <div class="message-bubble">
                  <div class="message-text">Hi, Kate</div>
                </div>
              </div>
            </div>

            <!-- Another sent message -->
            <div class="message message-sent">
              <div class="message-content">
                <div class="message-bubble">
                  <div class="message-text">How are you?</div>
                </div>
              </div>
            </div>

            <!-- Received message (by default - grey on left side) -->
            <div class="message message-received">
              <!-- Sender avatar -->
              <div class="message-avatar" style="background-image:url(path/to/avatar.jpg)"></div>
              <div class="message-content">
                <!-- Sender name -->
                <div class="message-name">Blue Ninja</div>
                <!-- Bubble with text -->
                <div class="message-bubble">
                  <div class="message-text">Hi there, I am also fine, thanks! And how are you?</div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    p
      b Messages page layout:
    ul
      li
        p `messages-content` - required additional class for messages wrapper. Should be added to `page-content`
      li
        p `messages` - required additional wrapper for messages bubbles. Required element.
      li
        p `messages-title` - messages title
      li
        p `message` - single message
    h3 Single Message Layout
    p Here is a full single message layout:
    :code(lang="html")
          <div class="message">
            <div class="message-avatar" style="background-image:url(path/to/avatar)"></div>
            <div class="message-content">
              <div class="message-name">John Doe</div>
              <div class="message-header">Message header</div>
              <div class="message-bubble">
                <div class="message-text-header">Text header</div>
                <div class="message-image">
                  <img src="path/to/image" />
                </div>
                <div class="message-text">Hello world!</div>
                <div class="message-text-footer">Text footer</div>
              </div>
              <div class="message-footer">Message footer</div>
            </div>
          </div>
    ul
      li
        p `message-avatar` - sender avatar, <em>optional</em>
      li
        p `message-name` - sender name, <em>optional</em>
      li
        p `message-header` - single message header, <em>optional</em>
      li
        p `message-text-header` - text header inside of bubble, <em>optional</em>
      li
        p `message-image` - message image, <em>optional</em>
      li
        p `message-text` - message text, <em>optional</em>
      li
        p `message-text-footer` - text footer inside of bubble, <em>optional</em>
      li
        p `message-footer` - footer text after bubble, <em>optional</em>
    h4 Additional classes for single message container
    ul
      li
        p `message-sent` - additional class for single message which indicates that this message was sent by user. It stays on right side with green background color.
      li
        p `message-received` - additional class for single message which indicates that this message was received by user. It stays on left side with grey background color.
      li
        p `message-tail` - additional class for single message (received or sent) to add bubble "tail"
      li
        p `message-same-name` - additional class for indicating that message has same sender name as previous message
      li
        p `message-same-avatar` - additional class for indicating that message has same avatar as previous message
      li
        p `message-same-header` - additional class for indicating that message has same message-header as previous message
      li
        p `message-same-footer` - additional class for indicating that message has same message-footer as previous message
      li
        p `message-last` - additional class for single message (received or sent) to indicate last received or last sent message in current conversation by one sender
      li
        p `message-first` - additional class for single message (received or sent) to indicate first received or first sent message in current conversation by one sender
    h2 Messages App Methods
    p Now, when we have Messages' HTML, we need to initialize it. We need to use related App's method:
    table.methods-table
      tbody
        tr
          td app.messages.create(<span>parameters</span>)
          td Initialize Messages with parameters
            ul.method-parameters
              li
                span.parameter parameters
                |  - <span class="parameter-type">object</span> - object with Messages parameters

              li.method-returns Method returns initialized Messages instance
        tr
          td app.messages.destroy(<span>el</span>)
          td Destroy Messages instance
            ul.method-parameters
              li
                span.parameter el
                |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector) or <span class="parameter-type">object</span>. Messages element or Messages instance to destroy.
        tr
          td app.messages.get(<span>el</span>)
          td Get Messages instance by HTML element
            ul.method-parameters
              li
                span.parameter el
                |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector). Messages element.
              li.method-returns Method returns Messages's instance
    h2 Messages Parameters
    p Let's look on list of all available parameters:
    table.params-table
      thead
        tr
          th Parameter
          th Type
          th Default
          th Description
      tbody
        tr
          td autoLayout
          td boolean
          td true
          td Enable Auto Layout to add all required additional classes automatically based on passed conditions
        tr
          td newMessagesFirst
          td boolean
          td false
          td Enable if you want to use new messages on top, instead of having them on bottom
        tr
          td scrollMessages
          td boolean
          td true
          td Enable/disable messages autoscrolling when adding new message
        tr
          td scrollMessagesOnEdge
          td boolean
          td true
          td If enabled then messages autoscrolling will happen only when user is on top/bottom of the messages view
        tr
          td messages
          td array
          td
            td Array with initial messages. Each message in array should be presented as an object with <a href="#single-message-parameters">single message parameters</a>
        tr
          td on
          td object
          td
          td
            p Object with events handlers. For example:
            :code(lang="js")
                  var messages = app.messages.create({
                    el: '.messages',
                    on: {
                      change: function () {
                        console.log('Textarea value changed')
                      }
                    }
                  })
        tr
          td renderMessage
          td function(message)
          td
          td Function to render single message. Must return full message HTML string
        tr
          th(colspan="4") Autolayout Conditions
        tr
          td firstMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-first` class will be added to message
        tr
          td lastMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-last` class will be added to message
        tr
          td tailMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-tail` class will be added to message
        tr
          td sameNameMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-same-name` class will be added to message
        tr
          td sameHeaderMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-same-header` class will be added to message
        tr
          td sameFooterMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-same-footer` class will be added to message
        tr
          td sameAvatarMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return boolean `true` or `false` based on required condition depending on previous and next messages. In case of match then `message-same-avatar` class will be added to message
        tr
          td customClassMessageRule
          td function(message, previousMessage, nextMessage)
          td
          td Function that must return additional message classes as string, based on required condition depending on previous and next messages.
    h2 Single Message Parameters
    p Let's look on single message parameters object that we should use when we pass `messages` array:
    table.params-table
      thead
        tr
          th Parameter
          th Type
          th Default
          th Description
      tbody
        tr
          td text
          td string
          td
          td Message text
        tr
          td header
          td string
          td
          td Single message header
        tr
          td footer
          td string
          td
          td Single message footer
        tr
          td name
          td string
          td
          td Sender name
        tr
          td avatar
          td string
          td
          td Sender avatar URL string
        tr
          td type
          td string
          td sent
          td Message type - `sent` or `received`
        tr
          td textHeader
          td string
          td
          td Message text header
        tr
          td textFooter
          td string
          td
          td Message text footer
        tr
          td image
          td string
          td
          td Message image HTML string, e.g. `<img src="path/to/image" />`. Can be used instead of `imageSrc` parameter
        tr
          td imageSrc
          td string
          td
          td Message image URL string. Can be used instead of `image` parameter
        tr
          td isTitle
          td boolean
          td
          td Defines whether it should be rendered as a message or as a messages title
        tr
          td cssClass
          td string
          td
          td Additional CSS class to set on message HTML element
        tr
          td attrs
          td object
          td
          td Object with additional HTML attributes to be set on message HTML element. For example to set extra `data` attributes it should look like:
            :code(lang="js")
              var message = {
                text: 'Hello!',
                attrs: {
                  'data-id': 1,
                  'data-author-id': 150
                }
              }
    h2 Messages Methods & Properties
    p So to create Messages we have to call:
    :code(lang="js")
          var messages = app.messages.create({ /* parameters */ })
    p After we initialize Messages we have its initialized instance in variable (like `messages` variable in example above) with helpful methods and properties:
    table.methods-table
      tbody
        tr
          th(colspan="2") Properties
        tr
          td messages.params
          td Object with passed initialization parameters
        tr
          td messages.el
          td Messages container HTML element (`<div class="messages">`)
        tr
          td messages.$el
          td Dom7 element with messages HTML element
        tr
          td messages.messages
          td Array with messages
        tr
          th(colspan="2") Methods
        tr
          td messages.showTyping(<span>message</span>)
          td Show typing message indicator
            ul.method-parameters
              li
                span.parameter message
                |  - <span class="parameter-type">object</span> - <a href="#single-message-parameters">parameters of message</a> to add
        tr
          td messages.hideTyping()
          td Hide typing message indicator
        tr
          td messages.addMessage(<span>message</span>, <span>method</span>, <span>animate</span>);
          td
            p Add new message to the end or to the beginning depending on <b>method</b> parameter
            ul.method-parameters
              li
                span.parameter message
                |  - <span class="parameter-type">object</span> - <a href="#single-message-parameters">parameters of message</a> to add. Required.
              li
                span.parameter method
                |  - <span class="parameter-type">string</span> - (`append` or `prepend`) dictates to add new message in the end or in the beginning of messages container. Optional, if not specified, then it will add message depending on `newMessagesFirst` parameter
              li
                span.parameter animate
                |  - <span class="parameter-type">boolean</span> - (by default <b>true</b>) You may pass here <b>false</b> and message will be added immediately without any transiton and scrolling animation. Optional.

              li.method-returns Method returns Messages instance
        tr
          td messages.addMessages(<span>messages</span>, <span>method</span>, <span>animate</span>);
          td Add multiple messages per once.
            ul.method-parameters
              li
                span.parameter messages
                |  - <span class="parameter-type">array</span> with messages to add. Each message in array should be presented as an object with <a href="#single-message-parameters">message parameters</a> Required.
              li.method-returns Method returns Messages instance
        tr
          td messages.removeMessage(<span>message</span>);
          td Remove message
            ul.method-parameters
              li
                span.parameter message
                |  - <span class="parameter-type">HTMLElement</span> or <span class="parameter-type">string</span> (with CSS Selector) or <span class="parameter-type">number</span> (with index number of message from `messages` array) of message to remove
              li.method-returns Method returns Messages instance
        tr
          td messages.removeMessages(<span>messages</span>);
          td Remove multiple messages
            ul.method-parameters
              li
                span.parameter messages
                |  - <span class="parameter-type">array</span> with messages to remove
              li.method-returns Method returns Messages instance
        tr
          td messages.scroll(<span>duration, position</span>);
          td Scroll messages to top/bottom depending on `newMessagesFirst` parameter
            ul.method-parameters
              li
                span.parameter duration
                |  - <span class="parameter-type">number</span> scroll duration in ms
              li
                span.parameter position
                |  - <span class="parameter-type">number</span> scroll position in px
        tr
          td messages.renderMessages()
          td Render messages HTML depending on `messages` array
        tr
          td messages.layout();
          td Force messages auto layout
        tr
          td messages.clear();
          td Clear/remove all the messages
        tr
          td messages.destroy();
          td Destroy messages instance
    h2 Messages Events
    p Messages will fire the following DOM events on messages element and events on app and messages instance:
    h3 DOM Events
    table.events-table
      thead
        tr
          th Event
          th Target
          th Description
      tbody
        tr
          td messages:beforedestroy
          td Messages Element<span>&lt;div class="messages"&gt;</span>
          td Event will be triggered right before Messages instance will be destroyed
    h3 App and Messages Instance Events
    p Messages instance emits events on both self instance and app instance. App instance events has same names prefixed with `messages`.
    table.events-table.double-events-table
      thead
        tr
          th Event
          th Target
          th Arguments
          th Description
      tbody
        tr
          td beforeDestroy
          td messages
          td(rowspan="2") <span>(messages)</span>
          td(rowspan="2") Event will be triggered right before Messages instance will be destroyed
        tr
          td messagesBeforeDestroy
          td app
    h2 Messages Auto Initialization
    p If you don't need to use Messages API and your Messages is inside of the page and presented in DOM on moment of page initialization then it can be auto initialized with just adding additional `messages-init` class to messages element, and all required parameters can be passed using `data-` attributes:
    :code(lang="html")
          <div class="messages messages-init" data-new-messages-first="true">
            ...
          </div>
    .important-note
      p Parameters that used in camelCase, for example <b>newMessagesFirst</b>, in data- attributes should be used in kebab-case as <b>data-new-messages-first</b>

    +cssVars('messages')


    h2 Examples
    +examplePreview('core', 'messages.html', 'messages')
